
/*
 * $Id: Agent.cc,v 1.4 1999/09/17 23:54:04 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "Socket.h"
#include "LogComment.h"
//#include "Rnd.h"
#include "Agent.h"
#include "AgentSym.h"
#include "SocketSym.h"

#include "globals.h"



Agent::Agent(): theThinkDistr(0) {
	theId.create();
}

Agent::~Agent() {
}

void Agent::configure(const AgentSym *cfg, SockOpt &opt) {
	Assert(TheFileScanner);
	Assert(cfg);

	theHost = cfg->host();
	theKind = cfg->kind();
	theThinkDistr = cfg->xactThink();

	// socket options
	bool ng = true;
	if (cfg->socket()->nagle(ng))
		opt.nagle = ng ? 1 : -1;
	cfg->socket()->lingerTout(opt.linger);
}

void Agent::start() {
	Comment(2) << "agent `" << theKind << "' starting on " << theHost << endc;
}
