
/*
 * $Id: DLog.cc,v 1.9 1999/09/07 17:46:06 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "polygraph.h"

#include "DLog.h"
#include "polyLogTags.h"


/* DLog */

DLog::DLog(): theFilter(0) {
}

DLog::~DLog() {
	while (theSources.count()) delete theSources.pop();
}

void DLog::filter(Filter aFilter) {
	Assert(!theFilter);
	theFilter = aFilter;
}

void DLog::noteRec(const StatIntvlRec &rec) {
	if (theFilter) {
		if (theCutter.update(theProgress.time()))
			pushAccStats();
		theCycleLxRec.theRec.concat(rec); // XXX: concat vs merge
	}
}

void DLog::noteRec(const StatPhaseRec &rec) {
	thePhaseLxRec.theRec.concat(rec); // XXX: concat vs merge
}

void DLog::pushAccStats() {
	if (theFilter) {
		(*theFilter)(*this);
		theCycleLxRec.theRec.restart();
	}
}
