
/*
 * $Id: ObjLifeCycle.h,v 1.6 1999/09/07 17:47:08 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef OBJECT_LIFE_CYCLE_H
#define OBJECT_LIFE_CYCLE_H

#include "Array.h"
#include "Rnd.h"

class ObjTimes;
class ObjLifeCycleSym;

// models object modification and expected expiration times
class ObjLifeCycle {
	protected:
		enum ExpGapType { egtNone, egtLmt, egtNow };

	public:
		ObjLifeCycle();
		~ObjLifeCycle();

		void configure(const ObjLifeCycleSym *cfg);

		//const RndDistr *modTime() const { return theModTime; }
		//const RndDistr *nowExpTime() const { return theNowExpTime; }
		//const RndDistr *modExpTime() const { return theModExpTime; }

		void bday(RndDistr *aDistr);
		void modVar(double aVar);
		void modTime(RndDistr *aDistr);
		void nowExpTime(RndDistr *aDistr);
		void modExpTime(RndDistr *aDistr);

		void calcTimes(int oid, ObjTimes &times);

	protected:
		int lmtDelta(int oid, int cycleCnt, int cycleLen);

	protected:
		RndGen theRng;
		RndDistr *theBday;
		RndDistr *theModTime;
		Array<RndDistr*> theExpires;
		RndDistr *theExpSelector;
		Array<ExpGapType> theExpGapTypes;

		double theModVar;        // "variation" in lmt
		double theShowModRatio;  // how many objs know their mod time
};

#endif
