
/*
 * $Id: ObjTimes.h,v 1.2 1999/09/07 17:47:09 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef OBJECT_TIMESTAMPS_H
#define OBJECT_TIMESTAMPS_H

class ObjLifeCycle;

// holds various object (entity) timestamps
class ObjTimes {
	friend ObjLifeCycle;

	public:
		ObjTimes() { reset(); }

		void reset();

		Time lmt() const { return theLmt; }
		Time exp() const { return theExp; }
		bool showLmt() const { return doShowLmt; }
		bool knownExp() const { return theExp >= 0; }

	protected:
		Time theLmt;
		Time theExp;
		bool doShowLmt;
};

#endif
