
/*
 * $Id: RndPermut.h,v 1.2 1999/09/07 17:47:16 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_RANDOM_PERMUTATION_H
#define PG_RANDOM_PERMUTATION_H

#include "LibInit.h"

// We often need to convert a number to some uncorrellated uniformly
// distributed random number. Using seed-and-trial approach with a r.n.g. 
// does not work well if input stream of numbers is sequential and long.
// The permutator is also useful for seeding a r.n.g.

// Note: current permutation allows for a given [small] number of 
// high quality random values. The size of the output set is a parameter.

// changes the permutation set; expensive; 
// can be called multiple times, any time
// using prime numbers for set size is recommended
extern void RndPermutConfig(int setSize, int seed = 1);

// set size remains unchanged, but contents changes
extern void RndPermutSeed(int seed);

// use second parameter if you need to map two numbers into one uniform var
extern int RndPermut(int n, int m = 0);

LIB_INITIALIZER(RndPermutfInit)

#endif
