
/*
 * $Id: StatCycle.h,v 1.4 1999/09/07 17:47:19 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PG_STAT_CYCLE_H
#define PG_STAT_CYCLE_H

#include "StatIntvl.h"

class Notifier;

typedef StatIntvlRec StatCycleRec;

// StatIntvRec stats are reset and logged every [short] time interval

class StatCycle: public StatIntvl {
	public:
		StatCycle();

		void period(Time aPeriod);
		void notifier(Notifier *aNotifier);

		virtual void wakeUp(const Alarm &alarm);

	protected:
		void nextIntvl(Time wakeUpTime);
		void restart();
		void report() const;

	protected:
		Time thePeriod;
		Notifier *theNotifier;
		StatCycleRec theRec;
};

#endif
