
/*
 * $Id: PglPopModelSym.cc,v 1.2 1999/09/17 23:54:51 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "pgl.h"

#include "Assert.h"
#include "String.h"
#include "PopModel.h"
#include "PglPopModelSym.h"


// XXX: we are leaking actual models here as they are never deleted!

PopModelSym::PopModelSym(const String &aType, PopModel *aVal): 
	ExpressionSym(aType), theVal(aVal) {
}

PopModelSym::~PopModelSym() {
}

bool PopModelSym::isA(const String &type) const {
	return ExpressionSym::isA(type) || type == "PopModel";
}

SynSym *PopModelSym::clone(const String &type) const {
	if (isA(type)) {
		PopModelSym *d = new PopModelSym(this->type(), theVal);
		return d;
	}
	return ExpressionSym::clone(type);
}

ostream &PopModelSym::print(ostream &os, const String &) const {
	if (theVal)
		theVal->print(os);
	else
		os << "<none>";
	return os;
}
