
/*
 * $Id: PglRecSym.h,v 1.7 1999/09/17 23:54:56 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_RECORD_SYMBOL_H
#define PGL_RECORD_SYMBOL_H

#include "Time.h"
#include "PglExprSym.h"

class PglRec;
class RndDistr;
class String;

class RecSym: public ExpressionSym {
	public:
		typedef PglRec Rec;

	public:
		RecSym(const String &aType, Rec *aRec): ExpressionSym(aType), theRec(aRec) {}
		virtual ~RecSym();

		Rec *rec() { return theRec; }

		virtual bool isA(const String &type) const;
		virtual SynSym *clone(const String &type) const;

		virtual ostream &print(ostream &os, const String &pfx = 0) const;

	protected:
		bool getBool(const String &name, bool &set) const;
		bool getDouble(const String &name, double &n) const;
		Time getTime(const String &name) const;
		RndDistr *getDistr(const String &name) const;

	protected:
		Rec *theRec;
};

#endif
