
/*
 * $Id: PopModel.h,v 1.2 1999/09/17 23:54:57 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef PGL_POP_MODEL_CLASS_H
#define PGL_POP_MODEL_CLASS_H

class ostream;
class RndGen;

// popularity model

class PopModel {
	public:
		virtual ~PopModel();

		// selects oid, adjusts for work set capacity
		int select(RndGen &rng, int lastOid, int wsCap);

		virtual ostream &print(ostream &os) const = 0;

	protected:
		// selects ignoring work set capacity
		virtual int select(RndGen &rng, int lastOid) = 0;
};

#endif
