
/*
 * $Id: Size.cc,v 1.3 1999/09/07 17:48:28 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#include "xstd.h"

#include <iostream.h>
#include <iomanip.h>

#include "Size.h"


ostream &Size::print(ostream &os) const {

	const int osprec = os.precision();
	os.precision(3);

	if (theSize < 1024)
		os << theSize;
	else
	if (theSize < 1024*1024)
		os << theSize/1024. << "KB";
	else
	if (theSize < 1024*1024*1024)
		os << theSize/(1024*1024.) << "MB";
	else
		os << theSize/(1024*1024*1024.) << "GB";

	os.precision(osprec);

	return os;
}
