
/*
 * $Id: SrcLoc.h,v 1.2 1999/09/07 17:48:45 rousskov Exp $
 *
 *
 * Web Polygraph                        http://polygraph.ircache.net/
 * ------------------------------------------------------------------
 *
 *  Web Polygraph is copyrighted (C) 1999 by Alex Rousskov and the
 *  University of California, San Diego (UCSD); all rights reserved.
 *
 *  You may copy and distribute VERBATIM copies of this product. 
 *  You may modify your copy for your own use. You must NOT
 *  distribute modified copies. You must NOT publish benchmarking
 *  results based on modified versions.
 *
 *  If you publish any materials derived from or related to Web
 *  Polygraph, you must give a credit reference to the IRCache group.
 *
 *  Web Polygraph is distributed without any warranty, even implied.
 *
 *  Please see the COPYRIGHT file for full details.
 *
 */

#ifndef XSTD_SOURCE_LOCATION_H
#define XSTD_SOURCE_LOCATION_H

#include "String.h"

#define Here SrcLoc(__FILE__, __LINE__)

class ostream;

// source location holder
class SrcLoc {
	public:
		SrcLoc(const String &aFname = 0, int aLineNo = 1);

		int lineno() const { return theLineNo; }
		const String &fname() const { return theFName; }

		operator void*() const { return theFName ? (void*)-1 : 0; }
		SrcLoc &operator ++() { ++theLineNo; return *this; }
		bool sameLine(const SrcLoc &t) const;

		ostream &print(ostream &os) const;

	protected:
		String theFName;
		int theLineNo;
};

inline ostream &operator <<(ostream &os, const SrcLoc &l) { return l.print(os); }

#endif
